unit modreport;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  ppCtrls, Db, DBTables, Wwquery, ppPrnabl, ppClass, ppBands, ppDB,
  ppDBBDE, ppCache, ppComm, ppReport, Grids, Wwdbigrd, Wwdbgrid, Wwdatsrc,
  ppStrtch, ppSubRpt, StdCtrls, ppMemo,  DBSecur, ppProd,
  ExtCtrls, ppTypes, RXCtrls, ppViewr;

type
  TfrmSQLADef = class(TForm)
    wwColumnDS: TwwDataSource;
    ppTableDef: TppReport;
    ppBDEColumn: TppBDEPipeline;
    ppReport1DBText2: TppDBText;
    ppReport1DBText3: TppDBText;
    ppReport1DBText4: TppDBText;
    wwColumnQ: TwwQuery;
    ppReport1DBText5: TppDBText;
    ppReport1Line1: TppLine;
    ppReport1DBText7: TppDBText;
    wwIndexQ: TwwQuery;
    wwIndexDS: TwwDataSource;
    wwTableQ: TwwQuery;
    ppBDEIndex: TppBDEPipeline;
    wwTableDS: TwwDataSource;
    ppReport1SubReport1: TppSubReport;
    ppReport1ChildReport1: TppChildReport;
    ppReport1ChildReport1DetailBand1: TppDetailBand;
    ppBDETable: TppBDEPipeline;
    ppReport1ChildReport1DBText1: TppDBText;
    ppReport1ChildReport1DBText2: TppDBText;
    ppReport1ChildReport1Label1: TppLabel;
    ppReport1ChildReport1Label2: TppLabel;
    ppReport1ChildReport1Label3: TppLabel;
    ppReport1Label1: TppLabel;
    ppReport1Label2: TppLabel;
    ppReport1Label3: TppLabel;
    ppReport1Label4: TppLabel;
    ppReport1Label5: TppLabel;
    ppReport1ChildReport1Line1: TppLine;
    ppReport1Label7: TppLabel;
    wwColumnQcreator: TStringField;
    wwColumnQcname: TStringField;
    wwColumnQtname: TStringField;
    wwColumnQcoltype: TStringField;
    wwColumnQnulls: TStringField;
    wwColumnQlength: TSmallintField;
    wwColumnQsyslength: TSmallintField;
    wwColumnQin_primary_key: TStringField;
    wwColumnQcolno: TSmallintField;
    wwColumnQdefault_value: TMemoField;
    wwColumnQremarks: TMemoField;
    ppStoredProcs: TppReport;
    wwStoredProcDS: TwwDataSource;
    wwStoredProcQ: TwwQuery;
    ppBDEPipeline1: TppBDEPipeline;
    ppReport2Label1: TppLabel;
    ppReport2DBText1: TppDBText;
    ppReport2DBMemo1: TppDBMemo;
    ppReport2Line1: TppLine;
    ppReport2Calc1: TppCalc;
    ppReport2Calc2: TppCalc;
    Label2: TLabel;
    wwTableQtable_id: TSmallintField;
    wwTableQfile_id: TSmallintField;
    wwTableQcount: TIntegerField;
    wwTableQfirst_page: TIntegerField;
    wwTableQlast_page: TIntegerField;
    wwTableQprimary_root: TIntegerField;
    wwTableQcreator: TSmallintField;
    wwTableQtable_name: TStringField;
    wwTableQtable_type: TStringField;
    wwTableQview_def: TMemoField;
    wwTableQremarks: TMemoField;
    wwTableQreplicate: TStringField;
    ppReport1DBMemo1: TppDBMemo;
    ppReport1DBMemo2: TppDBMemo;
    ppReport1Label8: TppLabel;
    ppReport2DBMemo2: TppDBMemo;
    Panel1: TPanel;
    ppReport1Shape2: TppShape;
    ppReport1Shape1: TppShape;
    ppReport1DBText1: TppDBText;
    ppReport1Label6: TppLabel;
    ppReport1Line8: TppLine;
    ppReport1Calc1: TppCalc;
    ppReport1Calc2: TppCalc;
    wwIndexQicreator: TStringField;
    wwIndexQiname: TStringField;
    wwIndexQfname: TMemoField;
    wwIndexQcreator: TStringField;
    wwIndexQtname: TStringField;
    wwIndexQindextype: TStringField;
    wwIndexQcolnames: TMemoField;
    wwIndexQinterval: TSmallintField;
    wwIndexQlevel_num: TSmallintField;
    ppReport1ChildReport1DBMemo1: TppDBMemo;
    ppReport1ChildReport1Label4: TppLabel;
    ppTableDefCalc1: TppCalc;
    ppTableDefShape1: TppShape;
    ppTableDefShape2: TppShape;
    ppTableDefLabel1: TppLabel;
    ppTableDefLine1: TppLine;
    Database1: TDatabase;
    Panel2: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    AliasCombo: TComboBox;
    wwDBGrid1: TwwDBGrid;
    wwDBGrid2: TwwDBGrid;
    Panel3: TPanel;
    RxLabel3: TRxLabel;
    Label4: TLabel;
    btnTblSelect: TButton;
    Button3: TButton;
    chkPreview: TCheckBox;
    chkColumnSort: TCheckBox;
    ppStoredProcsShape1: TppShape;
    ppStoredProcsShape2: TppShape;
    ppStoredProcsLabel1: TppLabel;
    ppStoredProcsLine1: TppLine;
    ppStoredProcsCalc1: TppCalc;
    Panel4: TPanel;
    RxLabel1: TRxLabel;
    Label7: TLabel;
    RxLabel2: TRxLabel;
    Label3: TLabel;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure AliasComboChange(Sender: TObject);
    procedure btnTblSelectClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure ppTableDefPreviewFormCreate(Sender: TObject);
    procedure ppStoredProcsPreviewFormCreate(Sender: TObject);
    procedure wwDBGrid1TitleButtonClick(Sender: TObject;
      AFieldName: String);
    procedure wwDBGrid2TitleButtonClick(Sender: TObject;
      AFieldName: String);
    procedure ppStoredProcsCalc1Calc(Sender: TObject);
    procedure ppTableDefCalc1Calc(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSQLADef: TfrmSQLADef;

implementation

{$R *.DFM}

procedure TfrmSQLADef.FormCreate(Sender: TObject);
var
MyStringList : TStringList;
I : Integer;
begin

MyStringList := TStringList.Create;
try
  Session.GetAliasNames(MyStringList);
  { fill a list box with alias names for the user to select from }
  for I := 0 to MyStringList.Count - 1 do
if Session.GetAliasDriverName(MyStringList[I])= 'Sybase SQL Anywhere 5.0' then
AliasCombo.Items.Add(MyStringList[I]);
finally
MyStringList.Free;
end;
end;

procedure TfrmSQLADef.AliasComboChange(Sender: TObject);
begin

if AliasCombo.Text <> '' then
 begin
   try
   Screen.Cursor := crHourGlass;
   wwDBGrid1.UnselectAll;
   wwDBGrid2.UnselectAll;
   wwTableQ.Close;
   wwColumnQ.Close;
   wwIndexQ.Close;
   wwStoredProcQ.Close;
   Database1.Connected := False;
   Database1.AliasName := AliasCombo.Text;
   Database1.Connected := True;
   wwTableQ.Open;
   wwColumnQ.Open;
   wwIndexQ.Open;
   wwStoredProcQ.Open;
   Screen.Cursor := crDefault;
   finally
   Screen.Cursor := crDefault;
   end;
 end;
end;

procedure TfrmSQLADef.btnTblSelectClick(Sender: TObject);
var
i: integer;
SQLStatement,SQLWhere: String;
begin
  if  wwdbgrid1.SelectedList.Count > 0 then
  begin
	with wwdbgrid1,wwdbgrid1.datasource.dataset do
	begin
		DisableControls; {Disable controls to improve performance}
		for i:= 0 to SelectedList.Count-1 do begin
			GotoBookmark(SelectedList.items[i]);
                        SQLWhere := SQLWhere + FieldByName('Table_id').asString + ',';
		end;
		EnableControls;  { Re-enable controls }
	end;
wwTableQ.Close;
wwTableQ.SQL.Clear;
SQLStatement := 'select * from SYSTABLE where Table_id IN (' ;
SQLStatement := SQLStatement + Copy(SQLWhere, 0, Length(SQLWhere)-1);
SQLStatement :=SQLStatement + ') order by table_name';
wwTableQ.SQL.Add(SQLStatement);
wwTableQ.Open;

wwColumnQ.Close;
wwColumnQ.SQL.Clear;
if chkColumnSort.checked = True then
SQLStatement := 'select * from SYSCOLUMNS where creator = ' + '''' + 'DBA' + '''' +
'AND tname = :table_name ORDER by tname,cname'
 else
 SQLStatement := 'select * from SYSCOLUMNS where creator = ' + '''' + 'DBA' + '''' +
'AND tname = :table_name ORDER by tname,colno';
wwColumnQ.SQL.Add(SQLStatement);
wwColumnQ.Open;

if chkPreview.checked = True then ppTableDef.Device := dvScreen
else ppTableDef.Device := dvPrinter;
ppTableDef.Print;

wwTableQ.Close;
wwTableQ.SQL.Clear;
wwTableQ.SQL.Add('select * from SYSTABLE where creator = 1 order by table_name');
wwTableQ.Open;
 end;
end;

procedure TfrmSQLADef.Button3Click(Sender: TObject);
var
i: integer;
SQLStatement,SQLWhere: String;
begin
 if  wwdbgrid2.SelectedList.Count > 0 then
 begin
	with wwdbgrid2,wwdbgrid2.datasource.dataset do
	begin
		DisableControls; {Disable controls to improve performance}
		for i:= 0 to SelectedList.Count-1 do begin
			GotoBookmark(SelectedList.items[i]);
                        SQLWhere := SQLWhere +  '''' + FieldByName('proc_name').asString + '''' + ',';
		end;
		EnableControls;  { Re-enable controls }
	end;
wwStoredProcQ.Close;
wwStoredProcQ.SQL.Clear;
SQLStatement := 'select * from sysprocedure where proc_name IN (' ;
SQLStatement := SQLStatement + Copy(SQLWhere, 0, Length(SQLWhere)-1);
SQLStatement :=SQLStatement  + ') order by proc_name';
wwStoredProcQ.SQL.Add(SQLStatement);
wwStoredProcQ.Open;
if chkPreview.checked = True then ppStoredProcs.Device := dvScreen
else ppStoredProcs.Device := dvPrinter;
ppStoredProcs.Print;
wwStoredProcQ.Close;
wwStoredProcQ.SQL.Clear;
wwStoredProcQ.SQL.Add('select * from sysprocedure where creator = 1');
wwStoredProcQ.Open;
end;

end;

procedure TfrmSQLADef.ppTableDefPreviewFormCreate(Sender: TObject);
begin
ppTableDef.PreviewForm.WindowState := wsMaximized;
TppViewer(ppTableDef.PreviewForm.Viewer).ZoomSetting := zsPageWidth
end;

procedure TfrmSQLADef.ppStoredProcsPreviewFormCreate(Sender: TObject);
begin
ppStoredProcs.PreviewForm.WindowState := wsMaximized;
end;

procedure TfrmSQLADef.wwDBGrid1TitleButtonClick(Sender: TObject;
  AFieldName: String);
begin
if wwdbgrid1.isSelected  then
wwDBGrid1.UnSelectAll else
wwDBGrid1.SelectAll;
end;

procedure TfrmSQLADef.wwDBGrid2TitleButtonClick(Sender: TObject;
  AFieldName: String);
begin
if wwdbgrid2.isSelected  then
wwDBGrid2.UnSelectAll else
wwDBGrid2.SelectAll;
end;

procedure TfrmSQLADef.ppStoredProcsCalc1Calc(Sender: TObject);
begin
ppStoredProcsCalc1.AsString := frmSQLADef.AliasCombo.Text;
end;

procedure TfrmSQLADef.ppTableDefCalc1Calc(Sender: TObject);
begin
ppTableDefCalc1.AsString := frmSQLADef.AliasCombo.Text;
end;

end.
